#include "stdafx.h"
#include "R3DBrain.h"


BOOL CreateBitmapSharpBrain(BITMAP_SHARP_BRAIN* pBitmap, LONG Width, LONG Height)
{
	LONG i;
	BITMAPINFOHEADER* pbih;
	DWORD* pMask;
	i = 1;
	while(i < 65536)
	{
		if(Width > i && Width < (i << 1))
			Width = i << 1;
		if(Height > i && Height < (i << 1))
			Height = i << 1;
		i = i << 1;
	}
	if(Width <= 0 || Height <= 0)
		return FALSE;
	pbih = (BITMAPINFOHEADER*)new BYTE[sizeof(BITMAPINFOHEADER) + sizeof(DWORD) * 3];
	if(!pbih)
		return FALSE;
	pMask = (DWORD*)((BYTE*)pbih + sizeof(BITMAPINFOHEADER));
	ZeroMemory(pbih, sizeof(BITMAPINFOHEADER));
	pbih->biSize = sizeof(BITMAPINFOHEADER);
	pbih->biWidth = Width;
	pbih->biHeight = Height * -1;
	pbih->biBitCount = PIXEL565_BITS;
	pbih->biPlanes = 1;
	pbih->biCompression = BI_BITFIELDS;
	pMask[0] = 0x0000f800;
	pMask[1] = 0x000007e0;
	pMask[2] = 0x0000001f;
	pBitmap->hBitmap = CreateDIBSection(NULL, (BITMAPINFO*)pbih, DIB_RGB_COLORS, (void**)&pBitmap->Bitmap.pBitmap, NULL, 0);
	delete []pbih;
	if(!pBitmap->hBitmap)
		return FALSE;
	pBitmap->Bitmap.Width = (SCALAR16)Width;
	pBitmap->Bitmap.Height = (SCALAR16)Height;
	pBitmap->Bitmap.MaskX = (SCALAR16)Width - 1;
	pBitmap->Bitmap.MaskY = (SCALAR16)Height - 1;
	pBitmap->Bitmap.ShiftX = 0;
	pBitmap->Bitmap.ShiftY = 0;
	while(Width > 1)
	{
		Width = Width >> 1;
		pBitmap->Bitmap.ShiftY++;
	}
	return TRUE;
}

void DestroyBitmapSharpBrain(BITMAP_SHARP_BRAIN* pBitmap)
{
	pBitmap->Bitmap.pBitmap = NULL;
	if(pBitmap->hBitmap)
		DeleteObject(pBitmap->hBitmap);
	pBitmap->hBitmap = NULL;
}

